Given a binary tree, return the vertical order traversal of its nodes values.
For each node at position (X, Y)
, its left and right children respectively will be at positions (X-1, Y-1)
and (X+1, Y-1)
.
Running a vertical line from X = -infinity
to X = +infinity
, whenever the vertical line touches some nodes, we report the values of the nodes in order from top to bottom (decreasing Y
coordinates).
If two nodes have the same position, then the value of the node that is reported first is the value that is smaller.
Return an list of non-empty reports in order of X
coordinate. Every report will have a list of values of nodes.
Example 1:
Input: [3,9,20,null,null,15,7] Output: [[9],[3,15],[20],[7]] Explanation: Without loss of generality, we can assume the root node is at position (0, 0): Then, the node with value 9 occurs at position (-1, -1); The nodes with values 3 and 15 occur at positions (0, 0) and (0, -2); The node with value 20 occurs at position (1, -1); The node with value 7 occurs at position (2, -2).
Example 2:
Input: [1,2,3,4,5,6,7] Output: [[4],[2],[1,5,6],[3],[7]] Explanation: The node with value 5 and the node with value 6 have the same position according to the given scheme. However, in the report "[1,5,6]", the node value of 5 comes first since 5 is smaller than 6.
Note:
- The tree will have between 1 and
1000
nodes. - Each node's value will be between
0
and1000
.
Related Topics:
Hash Table, Tree
Use a map<int, map<int, multiset<int>>> m
to store the values -- m[node->x][node->y].insert(node->val)
. (Using set
instead of multiset
can also pass this problem. I guess LeetCode uses the node values as IDs and assumes the uniqueness of the values. I used multiset
here to be safe.)
In this way, the values are sorted first in asending order of the x
values, then in asending order of y
values, then in asending order of node values.
Note that we shouldn't sort the values with the same X values all together, we should only sort them if they have the same position, i.e. when both their x
and y
values are equal.
// OJ: https://leetcode.com/problems/vertical-order-traversal-of-a-binary-tree/
// Author: github.com/lzl124631x
// Time: O(NlogN)
// Space: O(N)
class Solution {
map<int, map<int, multiset<int>>> m;
void dfs(TreeNode *root, int x, int y) {
if (!root) return;
m[x][y].insert(root->val);
dfs(root->left, x - 1, y + 1);
dfs(root->right, x + 1, y + 1);
}
public:
vector<vector<int>> verticalTraversal(TreeNode* root) {
dfs(root, 0, 0);
vector<vector<int>> ans;
for (auto &[x, mm] : m) {
ans.emplace_back();
for (auto &[y, vals] : mm) {
for (int n : vals) ans.back().push_back(n);
}
}
return ans;
}
};